C     HARDWARE-DETERMINED      
C     MACHINE CONSTANTS OBTAINED BY MACHAR, A SUBROUTINE DUE TO           
C     W. J. CODY.                                                         
C                                                                         
C     SUBPROGRAMS CALLED                                                  
C                                                                         
C       MINPACK-SUPPLIED ... SMCHAR,SPMPAR                                
c  updated to access MACHAR.F
C                                                                         
C     ARGONNE NATIONAL LABORATORY. MINPACK PROJECT. MARCH 1980.           
C     BURTON S. GARBOW, KENNETH E. HILLSTROM, JORGE J. MORE               
C                                                                         
C     **********                                                          
      INTEGER IBETA,IEXP,IRND,IT,MACHEP,MAXEXP,MINEXP,NEGEP,NGRD,         
     *        NWRITE                                                      
C                                                                         
C     LOGICAL OUTPUT UNIT IS ASSUMED TO BE NUMBER 6.                      
C                                                                         
      DATA NWRITE /6/                                                     
C                                                                         
C     DETERMINE THE MACHINE CONSTANTS DYNAMICALLY FROM SMCHAR.            
C                                                                         
      print*,' using machar_driver.f with call to machar.f'
      print*,' machar.f actually "computes" the machine constants'
c
      CALL MACHAR(IBETA,IT,IRND,NGRD,MACHEP,NEGEP,IEXP,MINEXP,MAXEXP,     
     *            EPS,EPSNEG,XMIN,XMAX)                                   
C                                                                         
C                                                                         
C     WRITE THE SMCHAR CONSTANTS.                                         
C                                                                         
      WRITE (NWRITE,10)                                                   
     *      IBETA,IT,IRND,NGRD,MACHEP,NEGEP,IEXP,MINEXP,MAXEXP,EPS,       
     *      EPSNEG,XMIN,XMAX                                              
C                                                                         
      STOP                                                                
   10 FORMAT (17H MACHAR CONSTANTS  // 8H IBETA =, I6 ,' radix',
     * // 8H IT    =, I6 ,' number of base ibeta digits in fraction',
     * // 8H IRND  =, I6 ,' 0 if fl pt add chops; 1 if rounds',
     * // 8H NGRD  =, I6 ,' number guard digits for multiply',
     * // 9H MACHEP =, I6,
     *     ' largest negative integer 1+ibeta**macheps != 1.',
     * // 8H NEGEP =, I6 , ' 1-ibeta**negeps != 1.',
     * // 7H IEXP =, I6 ,' number of bits in exponent',
     * // 9H MINEXP =, I6 , 
     * ' largest negative integer ibeta^minexp for valid fl pt number',
     * // 9H MAXEXP =, I6 ,
     * ' largest positive integer exponent for fl pt number',
     * // 6H EPS =, 1pE15.7 ,' fl pt unit round-off of machine',
     * // 9H EPSNEG =, 1pE15.7 ,'',
     * // 7H XMIN =,  1pE15.7 ,
     * ' smallest nonvanishing fl pt power of radix',
     * // 7H XMAX =,  1pE15.7,' largest finite fl pt number')              
C                                                                         
C     LAST CARD OF DRIVER.                                                
C                                                                         
      END                                                                 
